<?php
/*
+---------------------------------------------------------------+
|	e107 website system
|	e107_plugins/imagegallery_menu/imagegallery.php
|
|	 Mark Pustjens 2003
|	http://unkie.org
|	mark@unkie.org
|
|	 Chris McLeod 2002-2003
|	http://chrismcleod.net
|	me@chrismcleod.net
|
|	Released under the terms and conditions of the
|	GNU General Public License (http://gnu.org).	
+---------------------------------------------------------------+
*/

require_once("../../class2.php");
require_once(e_HANDLER."news_class.php");
require_once("../../e107_handlers/resize_handler.php");
require_once("languages/imagegallery_English.php");

if(file_exists("install.php")){ echo "<div class='installe' style='text-align:center'><b>*** ".LAN_00."</div><br /><br />"; }

if(!is_object($aj)){ $aj = new textparse; }

$tablecaption = "<a href=\"".e_SELF."\">".IGLAN_26."</a>";

// what does this do? it allows us to convert time stuf 
$con = new convert;

/*------------------ what functions do we use? -----------------------*/
function resize_img($imgname,$size){
  $ftype = explode(".",$imgname);
$imgname = "/home/apache/unkie.org/coppermine/albums/userpics/tolkien/normal_edoras.jpg";
	
  if (strtolower($ftype[1]) == "jpg"){
    $img_src = @ImageCreateFromJPEG ($imgname);
  }elseif(strtolower($ftype[1]) == "png"){
    $img_src = @ImageCreateFromPNG ($imgname);
  }
	
  $true_width = ImageSX($img_src);
  $true_height = ImageSY($img_src);
	
  if ($true_width>=$true_height) {
    $width=$size;
    $height = ($width/$true_width)*$true_height;
  } else {
    $height=$size;
    $width = ($height/$true_height)*$true_width;
  }
	 
  $img_des = ImageCreateTrueColor($width,$height);
  ImageCopyResized ($img_des, $img_src, 0, 0, 0, 0, $width, $height, $true_width, $true_height);
  return $img_des;
}

function thumbnail($file, $newsize)
{
  $filetype = getimagesize($file);
  $filetype = $filetype[2];

  switch ($filetype) {
    case 2:
      $image = imagecreatefromjpeg($file);
      break;
    case 3:
      $image = @imagecreatefrompng($file);
      break;
    case 1:
      $image = @imagecreatefromgif($file);
      break;
    case "default":
      echo "stom";
      break;
  }
  if (!$image) echo "vout";
 
  //calc new dimensions
  $orig_w = imagesx($image);
  $orig_h = imagesy($image);
  $new_w  = $newsize;
  $diff   = $orig_w / $new_w;
  $new_h  = $orig_h / $diff;
  $thumbnail = imagecreate($new_w,$new_h);
  imagecopyresized($thumbnail,$image,0,0,0,0,$new_w,$new_h,$orig_w,$orig_h);
  header("Content-type: image/jpeg");
  imagejpeg($thumbnail);
  imagedestroy($thumbnail);
  imagedestroy($image);
  return true;
}

/*----------- Handle Thumbnailing -------------*/
if (eregi("thumb.", e_QUERY)){
  $tqs = explode(".", e_QUERY);
  $thumbid = $tqs[1];

  $count = $sql->db_Select("images", "img_id, img_url", "img_id='$thumbid'");
  list( $img_id, 
	$img_url, ) = $sql->db_Fetch();
	
  thumbnail($img_url, 200);
	
/*  $thumbnail = resize_img($img_url, 200);
	
  if (strtolower($ftype[1]) == "jpg"){
    ob_start();
    header("Content-type: image/jpeg");
    ImageJPEG($thumbnail);
    ImageDestroy($thumbnail);
    ob_end_flush();
  } elseif (strtolower($ftype[1]) == "png"){
    ob_start();
    header("Content-type: image/png");
    ImagePNG($thumbnail);
    ImageDestroy($thumbnail);
    ob_end_flush();
  }*/
  exit;
}

require_once(HEADERF);

/* handles creation of `previous - next' bar for navigation
*/
function paging($url, $from, $view, $total, $td, $qs){
		/*
		# - parameter #1:		string $url, refer url
		# - parameter #2:		int $from, start figure
		# - parameter #3:		int $view, items per page
		# - parameter #4:		int $total, total items
		# - parameter #5:		string $td, comfort text
		# - parameter #6:		string $qs, QUERY_STRIING, default null
		# - return			null
		# - scope			public
		*/


  if($total == 0){
    return;
  }

  $text = "<table style=\"width:100%\"><tr>";
  $text .= "<td style=\"width:25%\" class=\"np\">";
  if ($from > 1){
    $s = $from - $view;
    $text .= "<div style=\"text-align:left\"><span class=\"smalltext\"><a href=\"".$url."?$qs.".$s.".".$view."\">&lt;&lt; ".IGLAN_17."</a></span></div>";
  } else {
    $text .= "<div style=\"text-align:left\"><span class=\"smalltext\">&lt;&lt; ".IGLAN_17."</span></div>";
  }
 
  $text .= "</td><td style=\"width:25%\" class=\"np\">";
  $start = $from + 1;
  $finish = $from + $view;
  if ($finish > $total){
    $finish = $total;
  }

  $text .= "<div style=\"text-align:center\"><span class=\"smalltext\">".IGLAN_20." <strong>$start - $finish ".IGLAN_19." $total</strong></span></div>";
  $text .= "</td>";

  $text .=  "<td style=\"width:25%\" class=\"np\">
	     <form method=\"post\" action=\"".$url."?$qs.".$from.".".$view."\">
	       ".IGLAN_21.": 	
	        <select name=\"view\" class=\"tbox\">
		  <option value=\"5\">5</option>
		  <option value=\"10\">10</option>
		  <option value=\"25\">25</option>
		  <option value=\"50\">50</option>
		</select>
		<input class='button' type='submit' name='changeview' value='".IGLAN_22."'>
	     </form>
	   </td>";

  $text .= "<td style=\"width:25%\" class=\"np\">";
  $s = $from + $view;
  if ($s < $total){
    $text .= "<div style=\"text-align:right\"><span class=\"smalltext\"><a href=\"".$url."?$qs.".$s.".".$view."\">".IGLAN_18." &gt;&gt;</a></span></div></td>";
  } else {
    $text .= "<div style=\"text-align:right\"><span class=\"smalltext\">".IGLAN_18." &gt;&gt;</span></div></td>";
  }

  $text .= "</tr></table>";

  return $text;
}

/*
if(USER == FALSE && $pref['anon_post'][1] != "1"){
  $text = "<div style=\"text-align:center\">".LAN_6."</div>";
  $ns -> tablerender($text, "");
  require_once(FOOTERF);
  exit;
}
*/

/* Display list of categories if no e_QUERY */
if (!e_QUERY){
  if ($sql->db_Select("images_category", "*", "img_category_class<255")){
    $text = "<div style=\"text-align:center;\"><table style=\"width:98%; border:0px;\" cellpadding=\"2\" cellspacing=\"4\">";
  
    $sql2 = new db;
    while (list($cat_id, $cat_name, $cat_desc, $cat_icon, $cat_class)=$sql -> db_Fetch()){
      $classok = check_class($cat_class);
      $count = $sql2->db_Count("images WHERE img_category='$cat_id'");
      $cat_desc = $aj->tpa($cat_desc);
      $text .= "<tr>
	          <td style=\"width:15%\">";
		    $text .= $classok ? "<a href=\"imagegallery.php?cat.$cat_id.0.5\">" : "";
      $text .=       "<img src=\"$cat_icon\" style=\"border:0px\" alt=\"\" />";
		    $text .= $classok ? "</a>" : "";
      $text .=	 "</td>
	          <td>";
		    $text .= $classok ? "<a href=\"imagegallery.php?cat.$cat_id.0.5\">" : "";
      $text .=       "$cat_name [$count images]";
		    $text .= $classok ? "</a>" : "";
      $text .=     "<br />$cat_desc";
		    $text .= !$classok ? "<br /><span class='smalltext'>(".IGLAN_28.")</span>" : "";
      $text .=	  "</td>
	        </tr>";
    }
    $text .= "</table></div>";
    $ns->tablerender(ICLAN_14, $text);
  } else {
    $ns->tablerender(ICLAN_14, "<strong>".IGLAN_27."</strong>");
  }
}

/* If we have "cat" in our QS, then we are viewing a category. */
if (eregi("cat.", e_QUERY)){
  $tmp = explode(".", e_QUERY);
  $cat = $tmp[1];
  $from = $tmp[2];
  $view = $tmp[3];
  if (IsSet($_POST['changeview'])) {
    $view = $_POST['view'];
  }
	
  $text = "";
  
  // check if this user has access to this class ...
  $sql->db_Select("images_category", "img_category_class", "img_category_id=$cat");
  list($class) = $sql->db_Fetch();
  if (check_class($class)) {
    $sql2 = new db;	
    $sql2->db_Select("images_category", "*", "img_category_id='$cat'");
    list($cat_id_, $cat_name_) = $sql2->db_Fetch();

    // if this evaluates true, one or more images are present in the database	
    if ($sql->db_Select("images", "*", "img_category='$cat' ORDER BY img_id DESC LIMIT $from,$view")){
      $count = $sql2->db_Count("images", "(*)", "WHERE img_category='$cat'");
														//img_admin stands for image poster	
      while (list($img_id, $img_title, $img_desc, $img_datestamp, $img_comments, $img_url, $img_thumb, $img_cat, $img_admin) = $sql->db_Fetch()){
	
	//convert and parse our data from the DB
	$img_datestamp = $con->convert_date($img_datestamp, "short");
	$img_title = $aj->tpa($img_title);
	$img_desc = $aj->tpa($img_desc);
		
	$sql2->db_Select("user", "user_name", "user_id='$img_admin'");
	list($username) = $sql2->db_Fetch();
	
	$text .= "<div style=\"padding-left:3px; padding-top:3px; padding-right:3px; padding-bottom:3px; text-align:center;\">
		    <table class=\"fborder\" style=\"width:98%; align:center;\" cellspacing=\"2\" cellpadding=\"2\">
		      <tr>
			 <td colspan=\"2\" class=\"forumtable3\"><span class=\"captiontext2\">$img_title</span></td>
		      </tr>
		      <tr>
			 <td style=\"width:25%; text-align:center;\" class=\"forumtable2\"><a href=\"imagegallery.php?view.$img_id\">";
	if ($img_thumb == 1){
	  $text .= 	   "<img src=\"".e_SELF."?thumb.$img_id\" style=\"border:0px;\" alt=\"thumbnail\" />";
	} else {
	  $text .= 	   IGLAN_15;
	}
	$text .=	   "<br />[".IGLAN_14."]</a>";
	$text .= ADMIN ? " <a href=\"img_conf.php?edit.".$img_id."\">[".IGLAN_31."]</a>" : "";
	$text .=	"</td>
			<td  style=\"text-align:left;\" class=\"forumtable2\">
			  $img_desc
			</td>
		       </tr>
		      <tr>
			<td colspan=\"2\" class=\"forumtable3\"><span class=\"smalltext\">
		 	  Submitted on: <strong>$img_datestamp</strong> by: <strong>$username</strong>.</span>
			</td>
		      </tr>
		    </table>
		  </div>";
      }
		
    //$from = $from+$view;
    $text .= paging("imagegallery.php", $from, $view, $count, "Images: $cat_name_", "cat.$cat");
    $message = "count is ".$count;
    $tablecaption .= " &gt <a href=\"".e_SELF."?cat.$cat.$from.$view\">$cat_name_</a>";
    $ns->tablerender($tablecaption, $text);
    } else {
      $ns->tablerender("Images: $cat_name_", "<strong>".IGLAN_29."</strong>");
    }
  } else {
    $ns->tablerender("Images: $cat_name_", "<strong>".IGLAN_30."</strong>");
  }
}

if(IsSet($_POST['submit'])){
  $id = $_POST['id'];
	
  $fp = new floodprotect;
  if ($fp->flood("comments", "comment_datestamp") == FALSE){
    header("location:index.php");
    die();
  }

  if(!$sql->db_Select("comments", "*", "comment_comment='".$_POST['comment']."' AND comment_item_id='$id' AND comment_type='11' ")){
    if($_POST['comment'] != ""){
      if(USER != TRUE){

	if($_POST['author_name'] == ""){
	  // anonymous user uploaded
	  $author = "0.Anonymous";
	} else {
	  // known user uploaded
	  $author = "0.". $aj -> tp($_POST['author_name'], "off", 1);
	}

      } else {

	$author = USERID.".".USERNAME;

      }

      $comment = $aj -> tp($_POST['comment'], "off", 1);
      $ip = getip();
      if (!eregi("Invalid", $comment) && $sql->db_Insert("comments", "0, '$id', '$author', '$author_email', '".time()."', '$comment', '0', '$ip', '11' ")){
	$sql->db_Update("user", "user_comments=user_comments+1, user_lastpost='".time()."' WHERE user_id='".USERID."' ");
      }

    }
  }
}

/* Finally, we deal with viewing a Images file */
if (eregi("view.", e_QUERY)){
  $tmp = explode(".", $_SERVER['QUERY_STRING']);
  $id = $tmp[1];
		
  $count = $sql->db_Select("images", "*", "img_id='$id'");
  list($img_id, $img_title, $img_desc, $img_datestamp, $img_comments, $img_url, $img_thumb, $img_category, $img_admin)=$sql->db_Fetch();

  // check if this user has access to this class ...
  $sql->db_Select("images_category", "img_category_class", "img_category_id=$img_category");
  list($class) = $sql->db_Fetch();
  if (check_class($class)) {
	
    $img_datestamp = $con->convert_date($img_datestamp, "short");
    $img_title = $aj->tpa($img_title);
    $img_desc = $aj->tpa($img_desc);

    $sql2 = new db;	
    $sql2->db_Select("user", "user_name", "user_id='$img_admin'");
    list($username) = $sql2->db_Fetch();
	
    $sql2->db_Select("images_category", "*", "img_category_id='$img_category'");
    list($cat_id_, $cat_name_)=$sql2->db_Fetch();
	
    if ($img_comments == 1){
      $comments=$sql2->db_Count("comments WHERE comment_type='11' AND comment_item_id='$img_id'");
      $sql2->db_Select("comments", "*", "comment_type='11' AND comment_item_id='$img_id'");
    } else {
      $comments = "turned off for this item.";
    }
	
    $text ="<table style=\"width:99%; border:0px; align:center;\" cellspacing=\"2\" cellpadding=\"0\" class=\"fborder\">
	      <tr>
	        <td class=\"forumtable2\"><div style=\"text-align:center; padding:4px;\">
		  <img src=\"$img_url\" style=\"border:0px;\" alt=\"$img_title\" />
		</div></td>
	      </tr>
	      <tr>
		<td>
		  <table width=\"100%\" class=\"border\" cellspacing=\"2\" cellpadding=\"0\">
		    <tr>
		      <td rowspan=\"2\" style=\"width:25%; padding:4px;\" class=\"forumtable3\">
			Posted By: <strong>$username</strong><br />
			Posted On: <strong>$img_datestamp</strong><br />
			Comments: <strong>$comments</strong>
		      </td>
		    <td style=\"width:75%; height:14px;\"><div class=\"border\"><div class=\"caption\">$img_title</div></div></td>
		      </tr>
		      <tr>
			<td style=\"padding:4px;\" class=\"forumtable2\">$img_desc</td>
		      </tr>
		    </table>
		  </td>
		</tr>
	      </table>";

  $tablecaption .= " &gt <a href=\"".e_SELF."?cat.$img_category.0.5\">$cat_name_</a> &gt <a href=\"".e_SELF."?".e_QUERY."\">$img_title</a>";
  $ns->tablerender($tablecaption, $text);
	
  if ($comments != 0){
    unset($text);
    $text = "";
    while(list($comment_id, $comment_item_id, $comment_author, $comment_author_email, $comment_datestamp, $comment_comment, $comment_blocked, $comment_ip) = $sql2-> db_Fetch()){
      $fca = eregi_replace("[0-9]+\.", "", $comment_author);

      $author_total = $sql -> db_Count("comments", "(*)", "WHERE comment_author='".$fca."' OR comment_author='$comment_author' ");
      $gen = new convert;
      $datestamp = $gen->convert_date($comment_datestamp, "short");
      $comment_author = $fca;

/*-------------------------------------------------- comment style -------------------------------------------*/
      $text .= "<table style=\"width:95%\">";

      if (defined("COMMENTSTYLE")){
	$text .= commentstyle($comment_id, $comment_author, $author_total, $datestamp, $comment_blocked, $comment_comment);
      } else {
	$unblock = "[<a href=\"admin/comment_conf.php?unblock-".$comment_id."-".$_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']."\">".LAN_1."</a>]";
	$block = "[<a href=\"admin/comment_conf.php?block-".$comment_id."-".$_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']."\">".LAN_2."</a>] ";
	$delete = "[<a href=\"admin/comment_conf.php?delete-".$comment_id."-".$_SERVER['PHP_SELF']."?".$_SERVER['QUERY_STRING']."\">".LAN_3."</a>] ";
	$userinfo = "[<a href=\"admin/userinfo.php?".$comment_ip."\">".LAN_4."</a>]";
	$text .= "<tr>
		    <td style=\"width:30%; vertical-align=top\">
		      <img src=\"".THEME."images/bullet2.gif\" alt=\"bullet\" /> 
		      <span class=\"defaulttext\"><i>$comment_author</i></span>
		      <br />
		      <span class=\"smalltext\">on $datestamp
		      <br />
		      Comments: ".$author_total."
		      </span>
		    </td>
		    <td style=\"width:70%; vertical-align=top\">
		      <span class=\"mediumtext\">";

	if ($comment_blocked == 1){
	  $text .= LAN_0;
	} else {
	  $text .= $aj->tpa($comment_comment);
	}	
				
	$text .=     "</span>
		    </td>";

	if (ADMIN == TRUE && getperms("B")){
	  $text .= "<td style=\"text-align:right\"><div class=\"smalltext\">";

	  if ($comment_blocked == 1){
	    $text .= $unblock;
	  } else {
	    $text .= $block;
	  }
	  $text .= $delete.$userinfo."</td>";
	}
	$text .= "</tr>";
      }

      $text .= "</table><br />";
    }
/*---------------------------------------------- end comment style -------------------------------------------*/
  $ns -> tablerender(LAN_5, $text);
  }

    $text = "<form method=\"post\" action=\"".e_SELF."?view.$id\">\n
	   <table style=\"width:95%\">";

    if ($pref['anon_post'][1] == "1" && USER == FALSE){
  $text .= "<tr>
	      <td style=\"width:20%\">".LAN_7."</td>
	      <td style=\"width:80%\">
		<input class=\"tbox\" type=\"text\" name=\"author_name\" size=\"60\" value=\"$author_name\" maxlength=\"100\" />
	      </td>
	    </tr>";
    }

    $text .= "<tr> 
	    <td style=\"width:20%\">".IGLAN_10."</td>
	    <td style=\"width:80%\">
	      <textarea class=\"tbox\" name=\"comment\" cols=\"70\" rows=\"10\"></textarea>
	    </td>
	  </tr>
	  <tr style=\"vertical-align:top\"> 
	    <td style=\"width:20%\"></td>
	    <td style=\"width:80%\">
	      <input type=\"hidden\" name=\"id\" value=\"$img_id\" />
	      <input class=\"button\" type=\"submit\" name=\"submit\" value=\"".IGLAN_9."\" />
	    </td>
	  </tr>
	</table>
      </form>";

    $ns -> tablerender(IGLAN_9, $text);
  } else {
    $ns->tablerender("Images: $cat_name_", "<strong>".IGLAN_30."</strong>");
  }
}

require_once(FOOTERF);
?>
